
surface cyslice_subd_matte( 
	float 	Ka 						= 0;	/* ambient 					*/
	float 	Kd 						= 1;	/* diffuse					*/
	string	cyslice_subd_color 		= "";	/* color map				*/
	string	cyslice_subd_normS 		= "";	/* texture space normal map	*/
	string	cyslice_subd_normU 		= "";	/* tangent space normal map	*/
	float	cyslice_subd_uvgrid		= 0 )	/* show UV grid				*/
{
    normal 	Nfacing;

	if( cyslice_subd_color != "")
	{
		Ci  = color texture( cyslice_subd_color, s, 1 - t);
	}
	else
	{
		Ci  = Cs;
	}

	if( cyslice_subd_uvgrid > 0)
	{
		float   map_u,
				map_v,
				mult;   	

		map_u   = smoothstep( 0.0, 1.25 * du, abs( (u * 1.0) - round( u * 1.0)));
		map_v   = smoothstep( 0.0, 1.25 * dv, abs( (v * 1.0) - round( v * 1.0)));

		mult	= min( map_u, map_v);

		Ci  	= (color( 0, 0, 0) * (1 - mult)) + (Ci * mult);  		
	}

	if( cyslice_subd_normU != "")
	{
		color	Ct;

		vector	Vs,
				Vt;
		
		matrix	M;

		normal	Nt,
				Nn;

		Nn	= normalize( N);

		Ct	= color
			texture( 
				cyslice_subd_normU,
				s,
				1 - t,
				"swidth", 0.0001,
				"twidth", 0.0001,
				"samples", 1);

		Nt	= normal( (Ct * 2) - 1);
		
		Vs	= normalize( dPdu);
		Vt	= normalize( Nn ^ Vs);
		Vs	= normalize( Vt ^ Nn);

		M	= matrix(
			comp( Vt, 0), comp( Vt, 1), comp( Vt, 2), 0,
			comp( Vs, 0), comp( Vs, 1), comp( Vs, 2), 0,
			comp( Nn, 0), comp( Nn, 1), comp( Nn, 2), 0,
			0,            0,            0,            1);

		N	= ntransform( M, Nt);
	}

	if( cyslice_subd_normS != "")
	{
		color	Ct;

		vector	Vs,
				Vt;
		
		matrix	M;

		normal	Nt,
				Nn;

		Nn	= normalize( N);

		Ct	= color 
			texture( 
				cyslice_subd_normS,
				s,
				1 - t,
				"swidth", 0.0001,
				"twidth", 0.0001,
				"samples", 1);

		Nt	= normal( (Ct * 2) - 1);
		
		Vs	= normalize( (dPdu * Dv( t)) - (dPdv * Du( t)));
		Vt	= normalize( Nn ^ Vs);
		Vs	= normalize( Vt ^ Nn);

		M	= matrix(
			comp( Vt, 0), comp( Vt, 1), comp( Vt, 2), 0,
			comp( Vs, 0), comp( Vs, 1), comp( Vs, 2), 0,
			comp( Nn, 0), comp( Nn, 1), comp( Nn, 2), 0,
			0,            0,            0,            1);

		N	= ntransform( M, Nt);
	}

    Nfacing	= faceforward( normalize( N), I);

    Oi = Os;
    Ci = Oi * Ci * ((Ka * ambient()) + (Kd * diffuse( Nfacing)));
}

